%% Berechnung von Fourierkoeffizienten 
% Sinus-Kosinus-Reihe und komplexe Exponentialfunktionen
%                                                         2020-2022 CB
clear variables
%% Die Funktion aus Aufgabe 87 der Übungsunterlagen
% hat Periode T 
T=1;
f=@(t) mod(t,T).^2;

t = linspace(-2,2,500);
plot(t,f(t))
axis equal

%% Sinus-Cosinus-Form
% Hier sind die Sinus/Cosinus-Integralformeln implementiert
n=5;
syms t a b T omg 
T=1;
omg = 2*pi/T;
a0 =2/T*int(t^2,t,0,T)

for k=1:n
a(k)= 2/T*int(t^2 *cos(k *omg *t),t,0,T);
b(k)= 2/T*int(t^2 *sin(k *omg *t),t,0,T);
end
a
b

% Zeichnen
t = linspace(0,2,1000);
ad = double(a);
bd=double(b);
fsum=double(a0/2)*ones(size(t));
for k=1:n
    fsum = fsum +ad(k)*cos(omg*k*t)+ bd(k)*sin(omg*k*t);
end
plot(t,f(t),t,fsum)

%% Komplexe Exponentialfunktion
% die Integralformeln in komplexer Schreibweise sind einfacher, schwierig
% ist nur, dass MATLAB nur positive indizes verwenden kann, daher werden
% Koeffizienten c_k mit k=-n:n auf c(m) mit m=1:2*n+1 gespeichert.
n=5;
syms t c T omg 
T=1;
omg = 2*pi/T;
for k=-n:n
    m = k+n+1; % kann Elemente mit negativen Indizes nicht speichern
    c(m) = int(t^2 *exp(-k *1i *omg *t),t,0,1);
end

% Tabelle der c-Koeffizienten (damit man die negativen Indizes besser
% findet)
syms ctab [3,2*n+1]

ctab(1,:)=-n:n;
ctab(2,:)=real(c);
ctab(3,:)=imag(c);
ctab

% Die Real- und Imaginaerteile sind die halben Cos- und Sin-Koeffizienten
% von oben! (Achtung, Vorzeichenwechsel bei Sin-Termen) 

% Die Zuordnung im Detail:
% c_0 = a_0 /2 
%
% Die Realteile von c_i für i = +-1, +-2, ... teilen sich brüderlich die
% Cosinus-Terme a_1, a_2, ...
% Re(c_(-i)) = Re(c_i) = a_i/2  
%
% Die Imaginärteile von c_i für i = +-1, +-2, ... teilen sich schwesterlich 
% die Sinus-Terme b_1, b_2, ...
% Im(c_(-i)) = -Im(c_i) = b_i/2         (Achtung, Vorzeichenwechsel!) 

% Zeichnen
t = linspace(0,2,500);
cd = double(c);
fsum=double(zeros(size(t)));
for k=-n:n
    m = k+n+1; % verschiebe in positiven Index-Bereich
    fsum = fsum +cd(m)*exp(1i*omg*k*t);
end
plot(t,f(t),t,fsum)
% Imaginaerteile im fsum-Vektor sind (bis auf Rundungsfehler) 0!



